package org.monaka.book.android.camera;

import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.view.SurfaceView;
import android.view.Window;
import android.view.WindowManager;

public class CameraActivity extends Activity {
	private MediaPlayer mediaPlayer;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.main);

		CameraPreview cameraPreview = (CameraPreview) findViewById(R.id.CameraPreview);
		SurfaceView surfaceView = (SurfaceView) findViewById(R.id.surfaceView);

		Bitmap kaodashiBitmap = BitmapFactory.decodeResource(getResources(),
				R.drawable.aduchan);
		PreviewCallback previewCallback = new PreviewCallback(kaodashiBitmap,
				surfaceView);
		cameraPreview.setPreviewCallback(previewCallback);
	}

	@Override
	protected void onPause() {
		super.onPause();

		mediaPlayer.stop();
		mediaPlayer.release();
	}

	@Override
	protected void onResume() {
		super.onResume();
		Context context = getApplicationContext();
		mediaPlayer = MediaPlayer.create(context, R.raw.kaodashi_bgm);
		mediaPlayer.setLooping(true);
		mediaPlayer.start();
	}
}