package org.monaka.book.android.camera;

import java.util.ArrayList;
import java.util.List;

import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.PointF;
import android.graphics.RectF;
import android.media.FaceDetector;
import android.media.FaceDetector.Face;

public class FaceDetect {

	public RectF[] faceDetect(Bitmap bitmap, int maxDetectCount) {
		Face faces[] = new Face[maxDetectCount];
		FaceDetector faceDetector = new FaceDetector(bitmap.getWidth(), bitmap.getHeight(), faces.length);

		Config config = bitmap.getConfig();
		Bitmap faceDetectBitmap;
		if (config == Config.RGB_565) {
			faceDetectBitmap = bitmap;
		} else {
			faceDetectBitmap = bitmap.copy(Bitmap.Config.RGB_565, true);
		}

		int detectCount = faceDetector.findFaces(faceDetectBitmap, faces);

		List<RectF> rectFList = new ArrayList<RectF>();
		for (int i = 0; i < detectCount; i++) {
			if (faces[i].confidence() >= 0.3) {
				PointF midPoint = new PointF();
				faces[i].getMidPoint(midPoint);
			    float eyesDistance = faces[i].eyesDistance();
			    RectF rectf = new RectF(); 
		        rectf.left = midPoint.x - (eyesDistance*2) ;
		        rectf.top = midPoint.y - (eyesDistance*2) ;
		        rectf.right = midPoint.x + (eyesDistance*2) ;
		        rectf.bottom = midPoint.y + (eyesDistance*2) ;
		        rectFList.add(rectf);
			}
		}

		return (RectF[]) rectFList.toArray(new RectF[rectFList.size()]);
	}
}
