package org.monaka.book.android.camera;

import java.io.IOException;
import java.io.InputStream;
import java.util.UUID;

import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.util.Log;

public class BluetoothThread extends Thread {
	private final static UUID SPP_UUID = UUID
			.fromString("00001101-0000-1000-8000-00805F9B34FB");
	private final static String TAG = BluetoothThread.class.getName();

	private BluetoothDevice bluetoothDevice;
	private BluetoothSocket bluetoothSocket;

	public BluetoothThread(BluetoothDevice bluetoothDevice) {
		this.bluetoothDevice = bluetoothDevice;
	}

	public void run() {
		InputStream inputStream;

		try {
			bluetoothSocket = bluetoothDevice
					.createRfcommSocketToServiceRecord(SPP_UUID);
		} catch (IOException e) {
			Log.e(TAG,
					"bluetoothDevice.createRfcommSocketToServiceRecord() failed",
					e);
			return;
		}

		Log.i(TAG, "SPP client connection established.");

		try {
			inputStream = bluetoothSocket.getInputStream();
			byte[] buffer = new byte[1024];
			int bytes;

			while (true) {

				bytes = inputStream.read(buffer);
			}
		} catch (IOException e) {
			Log.e(TAG, "disconnected", e);
		}
	}

	public void cancel() {
		try {
			bluetoothSocket.close();
		} catch (IOException e) {
			Log.e(TAG, "Can't close socket", e);
		}
	}

}
